unit schObrasClient_Intf;

interface

uses
  Classes, DB, schBase_Intf, SysUtils, uROClasses, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_Obras = '{0EF52B9A-E0CA-496B-B4E5-0F1CCE22F8B2}';

  { Data table names }
  nme_Obras = 'Obras';

  { Obras fields }
  fld_ObrasID = 'ID';
  fld_ObrasID_EMPRESA = 'ID_EMPRESA';
  fld_ObrasNOMBRE = 'NOMBRE';
  fld_ObrasCALLE = 'CALLE';
  fld_ObrasPROVINCIA = 'PROVINCIA';
  fld_ObrasPOBLACION = 'POBLACION';
  fld_ObrasCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_ObrasTELEFONO = 'TELEFONO';
  fld_ObrasMOVIL = 'MOVIL';
  fld_ObrasFAX = 'FAX';
  fld_ObrasPERSONA_CONTACTO = 'PERSONA_CONTACTO';
  fld_ObrasOBSERVACIONES = 'OBSERVACIONES';
  fld_ObrasID_CLIENTE = 'ID_CLIENTE';
  fld_ObrasNOMBRE_CLIENTE = 'NOMBRE_CLIENTE';
  fld_ObrasID_SUBCONTRATA = 'ID_SUBCONTRATA';
  fld_ObrasNOMBRE_SUBCONTRATA = 'NOMBRE_SUBCONTRATA';
  fld_ObrasFECHA_ALTA = 'FECHA_ALTA';
  fld_ObrasFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_ObrasUSUARIO = 'USUARIO';

  { Obras field indexes }
  idx_ObrasID = 0;
  idx_ObrasID_EMPRESA = 1;
  idx_ObrasNOMBRE = 2;
  idx_ObrasCALLE = 3;
  idx_ObrasPROVINCIA = 4;
  idx_ObrasPOBLACION = 5;
  idx_ObrasCODIGO_POSTAL = 6;
  idx_ObrasTELEFONO = 7;
  idx_ObrasMOVIL = 8;
  idx_ObrasFAX = 9;
  idx_ObrasPERSONA_CONTACTO = 10;
  idx_ObrasOBSERVACIONES = 11;
  idx_ObrasID_CLIENTE = 12;
  idx_ObrasNOMBRE_CLIENTE = 13;
  idx_ObrasID_SUBCONTRATA = 14;
  idx_ObrasNOMBRE_SUBCONTRATA = 15;
  idx_ObrasFECHA_ALTA = 16;
  idx_ObrasFECHA_MODIFICACION = 17;
  idx_ObrasUSUARIO = 18;

type
  { IObras }
  IObras = interface(IDAStronglyTypedDataTable)
  ['{97F3636B-5BD8-40D9-8BF9-BF90DA4AC15B}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetNOMBREIsNull: Boolean;
    procedure SetNOMBREIsNull(const aValue: Boolean);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetCALLEIsNull: Boolean;
    procedure SetCALLEIsNull(const aValue: Boolean);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetPROVINCIAIsNull: Boolean;
    procedure SetPROVINCIAIsNull(const aValue: Boolean);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPOBLACIONIsNull: Boolean;
    procedure SetPOBLACIONIsNull(const aValue: Boolean);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetCODIGO_POSTALIsNull: Boolean;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean);
    function GetTELEFONOValue: String;
    procedure SetTELEFONOValue(const aValue: String);
    function GetTELEFONOIsNull: Boolean;
    procedure SetTELEFONOIsNull(const aValue: Boolean);
    function GetMOVILValue: String;
    procedure SetMOVILValue(const aValue: String);
    function GetMOVILIsNull: Boolean;
    procedure SetMOVILIsNull(const aValue: Boolean);
    function GetFAXValue: String;
    procedure SetFAXValue(const aValue: String);
    function GetFAXIsNull: Boolean;
    procedure SetFAXIsNull(const aValue: Boolean);
    function GetPERSONA_CONTACTOValue: String;
    procedure SetPERSONA_CONTACTOValue(const aValue: String);
    function GetPERSONA_CONTACTOIsNull: Boolean;
    procedure SetPERSONA_CONTACTOIsNull(const aValue: Boolean);
    function GetOBSERVACIONESValue: IROStrings;
    function GetOBSERVACIONESIsNull: Boolean;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetID_CLIENTEIsNull: Boolean;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean);
    function GetNOMBRE_CLIENTEValue: String;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String);
    function GetNOMBRE_CLIENTEIsNull: Boolean;
    procedure SetNOMBRE_CLIENTEIsNull(const aValue: Boolean);
    function GetID_SUBCONTRATAValue: Integer;
    procedure SetID_SUBCONTRATAValue(const aValue: Integer);
    function GetID_SUBCONTRATAIsNull: Boolean;
    procedure SetID_SUBCONTRATAIsNull(const aValue: Boolean);
    function GetNOMBRE_SUBCONTRATAValue: String;
    procedure SetNOMBRE_SUBCONTRATAValue(const aValue: String);
    function GetNOMBRE_SUBCONTRATAIsNull: Boolean;
    procedure SetNOMBRE_SUBCONTRATAIsNull(const aValue: Boolean);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_ALTAIsNull: Boolean;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONIsNull: Boolean;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetUSUARIOIsNull: Boolean;
    procedure SetUSUARIOIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property TELEFONOIsNull: Boolean read GetTELEFONOIsNull write SetTELEFONOIsNull;
    property MOVIL: String read GetMOVILValue write SetMOVILValue;
    property MOVILIsNull: Boolean read GetMOVILIsNull write SetMOVILIsNull;
    property FAX: String read GetFAXValue write SetFAXValue;
    property FAXIsNull: Boolean read GetFAXIsNull write SetFAXIsNull;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property PERSONA_CONTACTOIsNull: Boolean read GetPERSONA_CONTACTOIsNull write SetPERSONA_CONTACTOIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NOMBRE_CLIENTEIsNull: Boolean read GetNOMBRE_CLIENTEIsNull write SetNOMBRE_CLIENTEIsNull;
    property ID_SUBCONTRATA: Integer read GetID_SUBCONTRATAValue write SetID_SUBCONTRATAValue;
    property ID_SUBCONTRATAIsNull: Boolean read GetID_SUBCONTRATAIsNull write SetID_SUBCONTRATAIsNull;
    property NOMBRE_SUBCONTRATA: String read GetNOMBRE_SUBCONTRATAValue write SetNOMBRE_SUBCONTRATAValue;
    property NOMBRE_SUBCONTRATAIsNull: Boolean read GetNOMBRE_SUBCONTRATAIsNull write SetNOMBRE_SUBCONTRATAIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
  end;

  { TObrasDataTableRules }
  TObrasDataTableRules = class(TIntfObjectDADataTableRules, IObras)
  private
    f_OBSERVACIONES: IROStrings;
    procedure OBSERVACIONES_OnChange(Sender: TObject);
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetCALLEIsNull: Boolean; virtual;
    procedure SetCALLEIsNull(const aValue: Boolean); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetPROVINCIAIsNull: Boolean; virtual;
    procedure SetPROVINCIAIsNull(const aValue: Boolean); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPOBLACIONIsNull: Boolean; virtual;
    procedure SetPOBLACIONIsNull(const aValue: Boolean); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetCODIGO_POSTALIsNull: Boolean; virtual;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean); virtual;
    function GetTELEFONOValue: String; virtual;
    procedure SetTELEFONOValue(const aValue: String); virtual;
    function GetTELEFONOIsNull: Boolean; virtual;
    procedure SetTELEFONOIsNull(const aValue: Boolean); virtual;
    function GetMOVILValue: String; virtual;
    procedure SetMOVILValue(const aValue: String); virtual;
    function GetMOVILIsNull: Boolean; virtual;
    procedure SetMOVILIsNull(const aValue: Boolean); virtual;
    function GetFAXValue: String; virtual;
    procedure SetFAXValue(const aValue: String); virtual;
    function GetFAXIsNull: Boolean; virtual;
    procedure SetFAXIsNull(const aValue: Boolean); virtual;
    function GetPERSONA_CONTACTOValue: String; virtual;
    procedure SetPERSONA_CONTACTOValue(const aValue: String); virtual;
    function GetPERSONA_CONTACTOIsNull: Boolean; virtual;
    procedure SetPERSONA_CONTACTOIsNull(const aValue: Boolean); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    function GetOBSERVACIONESIsNull: Boolean; virtual;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetID_CLIENTEIsNull: Boolean; virtual;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetNOMBRE_CLIENTEValue: String; virtual;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String); virtual;
    function GetNOMBRE_CLIENTEIsNull: Boolean; virtual;
    procedure SetNOMBRE_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetID_SUBCONTRATAValue: Integer; virtual;
    procedure SetID_SUBCONTRATAValue(const aValue: Integer); virtual;
    function GetID_SUBCONTRATAIsNull: Boolean; virtual;
    procedure SetID_SUBCONTRATAIsNull(const aValue: Boolean); virtual;
    function GetNOMBRE_SUBCONTRATAValue: String; virtual;
    procedure SetNOMBRE_SUBCONTRATAValue(const aValue: String); virtual;
    function GetNOMBRE_SUBCONTRATAIsNull: Boolean; virtual;
    procedure SetNOMBRE_SUBCONTRATAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_ALTAIsNull: Boolean; virtual;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONIsNull: Boolean; virtual;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetUSUARIOIsNull: Boolean; virtual;
    procedure SetUSUARIOIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property TELEFONOIsNull: Boolean read GetTELEFONOIsNull write SetTELEFONOIsNull;
    property MOVIL: String read GetMOVILValue write SetMOVILValue;
    property MOVILIsNull: Boolean read GetMOVILIsNull write SetMOVILIsNull;
    property FAX: String read GetFAXValue write SetFAXValue;
    property FAXIsNull: Boolean read GetFAXIsNull write SetFAXIsNull;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property PERSONA_CONTACTOIsNull: Boolean read GetPERSONA_CONTACTOIsNull write SetPERSONA_CONTACTOIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NOMBRE_CLIENTEIsNull: Boolean read GetNOMBRE_CLIENTEIsNull write SetNOMBRE_CLIENTEIsNull;
    property ID_SUBCONTRATA: Integer read GetID_SUBCONTRATAValue write SetID_SUBCONTRATAValue;
    property ID_SUBCONTRATAIsNull: Boolean read GetID_SUBCONTRATAIsNull write SetID_SUBCONTRATAIsNull;
    property NOMBRE_SUBCONTRATA: String read GetNOMBRE_SUBCONTRATAValue write SetNOMBRE_SUBCONTRATAValue;
    property NOMBRE_SUBCONTRATAIsNull: Boolean read GetNOMBRE_SUBCONTRATAIsNull write SetNOMBRE_SUBCONTRATAIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ TObrasDataTableRules }
constructor TObrasDataTableRules.Create(aDataTable: TDADataTable);
var
  StrList: TStringList;
begin
  inherited;

  StrList := TStringList.Create;
  StrList.OnChange := OBSERVACIONES_OnChange;
  f_OBSERVACIONES := NewROStrings(StrList,True);
end;

destructor TObrasDataTableRules.Destroy;
begin
  inherited;
end;

procedure TObrasDataTableRules.OBSERVACIONES_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_ObrasOBSERVACIONES].AsVariant := TStringList(Sender).Text;
end;

function TObrasDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_ObrasID].AsInteger;
end;

procedure TObrasDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ObrasID].AsInteger := aValue;
end;

function TObrasDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasID].IsNull;
end;

procedure TObrasDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasID].AsVariant := Null;
end;

function TObrasDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_ObrasID_EMPRESA].AsInteger;
end;

procedure TObrasDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ObrasID_EMPRESA].AsInteger := aValue;
end;

function TObrasDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasID_EMPRESA].IsNull;
end;

procedure TObrasDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasID_EMPRESA].AsVariant := Null;
end;

function TObrasDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_ObrasNOMBRE].AsString;
end;

procedure TObrasDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasNOMBRE].AsString := aValue;
end;

function TObrasDataTableRules.GetNOMBREIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasNOMBRE].IsNull;
end;

procedure TObrasDataTableRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasNOMBRE].AsVariant := Null;
end;

function TObrasDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_ObrasCALLE].AsString;
end;

procedure TObrasDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasCALLE].AsString := aValue;
end;

function TObrasDataTableRules.GetCALLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasCALLE].IsNull;
end;

procedure TObrasDataTableRules.SetCALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasCALLE].AsVariant := Null;
end;

function TObrasDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_ObrasPROVINCIA].AsString;
end;

procedure TObrasDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasPROVINCIA].AsString := aValue;
end;

function TObrasDataTableRules.GetPROVINCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasPROVINCIA].IsNull;
end;

procedure TObrasDataTableRules.SetPROVINCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasPROVINCIA].AsVariant := Null;
end;

function TObrasDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_ObrasPOBLACION].AsString;
end;

procedure TObrasDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasPOBLACION].AsString := aValue;
end;

function TObrasDataTableRules.GetPOBLACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasPOBLACION].IsNull;
end;

procedure TObrasDataTableRules.SetPOBLACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasPOBLACION].AsVariant := Null;
end;

function TObrasDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_ObrasCODIGO_POSTAL].AsString;
end;

procedure TObrasDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasCODIGO_POSTAL].AsString := aValue;
end;

function TObrasDataTableRules.GetCODIGO_POSTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasCODIGO_POSTAL].IsNull;
end;

procedure TObrasDataTableRules.SetCODIGO_POSTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasCODIGO_POSTAL].AsVariant := Null;
end;

function TObrasDataTableRules.GetTELEFONOValue: String;
begin
  result := DataTable.Fields[idx_ObrasTELEFONO].AsString;
end;

procedure TObrasDataTableRules.SetTELEFONOValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasTELEFONO].AsString := aValue;
end;

function TObrasDataTableRules.GetTELEFONOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasTELEFONO].IsNull;
end;

procedure TObrasDataTableRules.SetTELEFONOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasTELEFONO].AsVariant := Null;
end;

function TObrasDataTableRules.GetMOVILValue: String;
begin
  result := DataTable.Fields[idx_ObrasMOVIL].AsString;
end;

procedure TObrasDataTableRules.SetMOVILValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasMOVIL].AsString := aValue;
end;

function TObrasDataTableRules.GetMOVILIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasMOVIL].IsNull;
end;

procedure TObrasDataTableRules.SetMOVILIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasMOVIL].AsVariant := Null;
end;

function TObrasDataTableRules.GetFAXValue: String;
begin
  result := DataTable.Fields[idx_ObrasFAX].AsString;
end;

procedure TObrasDataTableRules.SetFAXValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasFAX].AsString := aValue;
end;

function TObrasDataTableRules.GetFAXIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasFAX].IsNull;
end;

procedure TObrasDataTableRules.SetFAXIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasFAX].AsVariant := Null;
end;

function TObrasDataTableRules.GetPERSONA_CONTACTOValue: String;
begin
  result := DataTable.Fields[idx_ObrasPERSONA_CONTACTO].AsString;
end;

procedure TObrasDataTableRules.SetPERSONA_CONTACTOValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasPERSONA_CONTACTO].AsString := aValue;
end;

function TObrasDataTableRules.GetPERSONA_CONTACTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasPERSONA_CONTACTO].IsNull;
end;

procedure TObrasDataTableRules.SetPERSONA_CONTACTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasPERSONA_CONTACTO].AsVariant := Null;
end;

function TObrasDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := f_OBSERVACIONES;
  result.Text := DataTable.Fields[idx_ObrasOBSERVACIONES].AsString;
end;

function TObrasDataTableRules.GetOBSERVACIONESIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasOBSERVACIONES].IsNull;
end;

procedure TObrasDataTableRules.SetOBSERVACIONESIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasOBSERVACIONES].AsVariant := Null;
end;

function TObrasDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_ObrasID_CLIENTE].AsInteger;
end;

procedure TObrasDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ObrasID_CLIENTE].AsInteger := aValue;
end;

function TObrasDataTableRules.GetID_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasID_CLIENTE].IsNull;
end;

procedure TObrasDataTableRules.SetID_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasID_CLIENTE].AsVariant := Null;
end;

function TObrasDataTableRules.GetNOMBRE_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_ObrasNOMBRE_CLIENTE].AsString;
end;

procedure TObrasDataTableRules.SetNOMBRE_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasNOMBRE_CLIENTE].AsString := aValue;
end;

function TObrasDataTableRules.GetNOMBRE_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasNOMBRE_CLIENTE].IsNull;
end;

procedure TObrasDataTableRules.SetNOMBRE_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasNOMBRE_CLIENTE].AsVariant := Null;
end;

function TObrasDataTableRules.GetID_SUBCONTRATAValue: Integer;
begin
  result := DataTable.Fields[idx_ObrasID_SUBCONTRATA].AsInteger;
end;

procedure TObrasDataTableRules.SetID_SUBCONTRATAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ObrasID_SUBCONTRATA].AsInteger := aValue;
end;

function TObrasDataTableRules.GetID_SUBCONTRATAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasID_SUBCONTRATA].IsNull;
end;

procedure TObrasDataTableRules.SetID_SUBCONTRATAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasID_SUBCONTRATA].AsVariant := Null;
end;

function TObrasDataTableRules.GetNOMBRE_SUBCONTRATAValue: String;
begin
  result := DataTable.Fields[idx_ObrasNOMBRE_SUBCONTRATA].AsString;
end;

procedure TObrasDataTableRules.SetNOMBRE_SUBCONTRATAValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasNOMBRE_SUBCONTRATA].AsString := aValue;
end;

function TObrasDataTableRules.GetNOMBRE_SUBCONTRATAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasNOMBRE_SUBCONTRATA].IsNull;
end;

procedure TObrasDataTableRules.SetNOMBRE_SUBCONTRATAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasNOMBRE_SUBCONTRATA].AsVariant := Null;
end;

function TObrasDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_ObrasFECHA_ALTA].AsDateTime;
end;

procedure TObrasDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ObrasFECHA_ALTA].AsDateTime := aValue;
end;

function TObrasDataTableRules.GetFECHA_ALTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasFECHA_ALTA].IsNull;
end;

procedure TObrasDataTableRules.SetFECHA_ALTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasFECHA_ALTA].AsVariant := Null;
end;

function TObrasDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_ObrasFECHA_MODIFICACION].AsDateTime;
end;

procedure TObrasDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ObrasFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TObrasDataTableRules.GetFECHA_MODIFICACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasFECHA_MODIFICACION].IsNull;
end;

procedure TObrasDataTableRules.SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasFECHA_MODIFICACION].AsVariant := Null;
end;

function TObrasDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_ObrasUSUARIO].AsString;
end;

procedure TObrasDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_ObrasUSUARIO].AsString := aValue;
end;

function TObrasDataTableRules.GetUSUARIOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ObrasUSUARIO].IsNull;
end;

procedure TObrasDataTableRules.SetUSUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ObrasUSUARIO].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID_Obras, TObrasDataTableRules);

end.
